/*************************************************************************
Title:    Analoginiu iejimu testavimas su LCD
Author:   Levas
File:     
Software: AVR-GCC 3.3
Hardware: Levo ATMEGA16 testavimo modulis
**************************************************************************/
#define F_CPU 12000000UL
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "lcd.h"
#include <util\delay.h>

int main(void)
{
    char buffer[16];
	int x=0;
    unsigned char i,j;
    
    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);
    lcd_clrscr();   /* clear display home cursor */
	lcd_puts("Stepas : ");
	//	lcd_puts("Kanalas: ");	
	lcd_gotoxy(0,1);
	lcd_puts("Reiksme:");
    for (;;) {                           /* loop forever */

			for(i=0; i<8; i++)
			{
			lcd_gotoxy(8,0);  
			lcd_puts("  ");
			lcd_gotoxy(8,0);  
			itoa( i, buffer, 10);
			lcd_puts(buffer);
			// Select pin ADC0 using MUX
			ADMUX = 0;
			// Jei atkomentuoti sita apacioje, tai vietoje stepo bus pasirinktas kanalas.
			// ADMUX =i;
			
			//Apie visus situs bitus geriau pasiskaityti ATMEGA16 datasheete.
			ADCSRA |=_BV(ADEN);
			ADCSRA |=_BV(ADPS0) | _BV(ADPS1) | _BV(ADPS2);
			ADMUX= _BV(REFS0);
			ADCSRA |=_BV(ADSC);
			loop_until_bit_is_set(ADCSRA, ADIF); //uzsiciklinam kol nebaigs darba ADC.
			x=ADCW;
			lcd_gotoxy(7,1);  
			lcd_puts(":     ");
			lcd_gotoxy(8,1);	
			itoa( x, buffer, 10);
			lcd_puts(buffer);
			for(j=0; j<50; j++){
				_delay_ms(20);} // pauzike, kad pernelyg greitai nesikeistu skaiciukai. ~50x20=~1000ms=~1s.	
			}
    }
}
